package com.framsticks.gui;

import com.framsticks.params.AccessInterface;
import com.framsticks.params.CompositeParam;
import com.framsticks.params.FramsClass;
// import org.apache.log4j.Logger;

import javax.swing.*;

/**
 * Author: Piotr Śniegowski
 */
@SuppressWarnings("serial")
public abstract class Panel extends JPanel {

	public static class Parameters {
		public final EndpointAtFrame endpoint;
		public final CompositeParam param;
		public final FramsClass framsClass;

		public Parameters(EndpointAtFrame endpoint, CompositeParam param, FramsClass framsClass) {
			this.endpoint = endpoint;
			this.param = param;
			this.framsClass = framsClass;
		}
	}

	// private static final Logger log = Logger.getLogger(Panel.class.getName());

	protected TreeNode currentTreeNode;
	protected final EndpointAtFrame endpoint;
	protected final Frame frame;
	protected final String className;
	protected final FramsClass framsClass;
	protected final CompositeParam param;
	protected String uniqueName = "?";

	public Panel(Parameters parameters) {
		this.endpoint = parameters.endpoint;
		this.frame = parameters.endpoint.getFrame();
		this.framsClass = parameters.framsClass;
		this.param = parameters.param;
		this.className = parameters.param.getContainedTypeName();
		this.setName(parameters.param.getFramsTypeName());
	}

	public void setCurrentTreeNode(TreeNode currentTreeNode) {
		this.currentTreeNode = currentTreeNode;
	}

	public TreeNode getCurrentTreeNode() {
		return currentTreeNode;
	}

	public final Frame getFrame() {
		return frame;
	}

	public final EndpointAtFrame getEndpointAtFrame() {
		return endpoint;
	}


	public final String getClassName() {
		return className;
	}

	public abstract void pullValuesFromLocalToUser(AccessInterface access);

	@Override
	public String toString() {
		return uniqueName;
	}

	public final String getUniqueName() {
		return uniqueName;
	}

	public abstract String getTitle();
}
